/// Use as a mixin for const constructor
abstract class SubUnion2<A extends SubUnion2<A, B>, B extends SubUnion2<A, B>> {
  R map<R>(R Function(A) a, R Function(B) b) {
    final self = this;
    if (self is A) {
      return a(self);
    } else if (self is B) {
      return b(self);
    } else {
      throw Exception("${this
          .runtimeType} was not handled properly. No action implemented");
    }
  }
}

/// Use as a mixin for const constructor
abstract class SubUnion3<A extends SubUnion3<A, B, C>, B extends SubUnion3<A,
    B,
    C>, C extends SubUnion3<A, B, C>> {
  R map<R>(R Function(A) a, R Function(B) b, R Function(C) c) {
    final self = this;
    if (self is A) {
      return a(self);
    } else if (self is B) {
      return b(self);
    } else if (self is C) {
      return c(self);
    } else {
      throw Exception("${this
          .runtimeType} was not handled properly. No action implemented");
    }
  }
}

/// Use as a mixin for const constructor
abstract class SubUnion4<A extends SubUnion4<A, B, C, D>, B extends SubUnion4<A,
    B,
    C,
    D>, C extends SubUnion4<A, B, C, D>, D extends SubUnion4<A, B, C, D>> {
  R map<R>(R Function(A) a, R Function(B) b, R Function(C) c, R Function(D) d) {
    final self = this;
    if (self is A) {
      return a(self);
    } else if (self is B) {
      return b(self);
    } else if (self is C) {
      return c(self);
    } else if (self is D) {
      return d(self);
    } else {
      throw Exception("${this
          .runtimeType} was not handled properly. No action implemented");
    }
  }
}

/// Use as a mixin for const constructor
abstract class SubSubUnion2<A extends SubSubUnion2<A,
    B>, B extends SubSubUnion2<A, B>> {
  R subMap<R>(R Function(A) a, R Function(B) b) {
    final self = this;
    if (self is A) {
      return a(self);
    } else if (self is B) {
      return b(self);
    } else {
      throw Exception("${this
          .runtimeType} was not handled properly. No action implemented");
    }
  }
}

/// Use as a mixin for const constructor
abstract class SubSubUnion3<
A extends SubSubUnion3<A, B, C>,
B extends SubSubUnion3<A, B, C>,
C extends SubSubUnion3<A, B, C>
> {
  R subMap<R>(R Function(A) a, R Function(B) b, R Function(C) c) {
    if (this is A) {
      return a(this as A);
    } else if (this is B) {
      return b(this as B);
    } else if (this is C) {
      return c(this as C);
    } else {
      throw Exception("${this
          .runtimeType} was not handled properly. No action implemented");
    }
  }
}

/// Use as a mixin for const constructor
abstract class SubSubUnion8<
A extends SubSubUnion8<A, B, C, D, E, F, G, H>,
B extends SubSubUnion8<A, B, C, D, E, F, G, H>,
C extends SubSubUnion8<A, B, C, D, E, F, G, H>,
D extends SubSubUnion8<A, B, C, D, E, F, G, H>,
E extends SubSubUnion8<A, B, C, D, E, F, G, H>,
F extends SubSubUnion8<A, B, C, D, E, F, G, H>,
G extends SubSubUnion8<A, B, C, D, E, F, G, H>,
H extends SubSubUnion8<A, B, C, D, E, F, G, H>
> {
  R subMap<R>(R Function(A) a,
      R Function(B) b,
      R Function(C) c,
      R Function(D) d,
      R Function(E) e,
      R Function(F) f,
      R Function(G) g,
      R Function(H) h,) {
    if (this is A) {
      return a(this as A);
    } else if (this is B) {
      return b(this as B);
    } else if (this is C) {
      return c(this as C);
    } else if (this is D) {
      return d(this as D);
    } else if (this is E) {
      return e(this as E);
    } else if (this is F) {
      return f(this as F);
    } else if (this is G) {
      return g(this as G);
    } else if (this is H) {
      return h(this as H);
    } else {
      throw Exception("${this
          .runtimeType} was not handled properly. No action implemented");
    }
  }
}