import 'package:bird/signal_wave.dart';
import 'package:bird/signal_wave_plus.dart';
import 'package:bird/smart_api.dart';
import 'package:dartz/dartz.dart';
import 'package:bird/bird.dart';

class OEWave<T> extends OptionWave<Either<AllErrors, T>> {
  static OEWave<T> from<T>(WaveType<Option<Either<AllErrors, T>>> wave) =>
      OEWave<T>(wave);

  OEWave(WaveType<Option<Either<AllErrors, T>>> wave) : super(wave);

  OptionWave<AllErrors> left() =>
      map((a) => a.bind<AllErrors>((a) => a.toLeftOption())).as(OptionWave.from);

  OptionWave<T> right() =>
      map((a) => a.bind((a) => a.toOption())).as(OptionWave.from);
}
