/// TODO creditmanager
//import 'dart:convert';
//
//import 'package:meta/meta.dart';
//
///// API Sources can have a limited amount of credits that
///// will run out when to many calls are made.
/////
///// They regenerate after a certain time that if defined
///// by [APICreditManagerPolicy.durationOfCompleteRenewal]
//class APICreditManager {
//
//    /// Contains the model state to calculate
//    /// the next regeneration time and keep track
//    /// of the last credit balance
//    ///
//    /// Each access should recalculate the available credits
//    /// before passing it on and wait for a callback that says
//    /// whether it did use up the credits or not
//    APICreditModel model;
//
//    /// Describes the initial amount of credits and
//    /// after what time they regenerate back
//    APICreditManagerPolicy policy;
//
//    APICreditManager({
//        @required this.model,
//        @required this.policy,
//    });
//}
//
///// This information has to be provided by an API
///// that has to follow credit limitations
//class APICreditManagerPolicy {
//
//    /// A unique that is used to identify to which
//    /// api this policy belongs to.
//    ///
//    /// Also used for storage purposes of the
//    /// [APICreditModel]
//    String id;
//
//    /// If the last renewal is before now - this
//    /// then the credits are restored again to [completeCreditCount]
//    Optional<Duration> durationOfCompleteRenewal;
//
//    /// The amount of initial credits and how many credits there are
//    /// when the credits have been fully renewed
//    ///
//    /// If this is null then an API has unlimited credits therefore
//    /// [durationOfCompleteRenewal] is ignored and no [APICreditModel]
//    /// should be saved
//    Optional<int> completeCreditCount;
//
//    APICreditManagerPolicy({
//        @required this.durationOfCompleteRenewal,
//        @required this.completeCreditCount,
//        @required this.id,
//    });
//}
//
///// An API Call has to have an [APICreditCost]
/////
///// Call [APICreditCost.none] if a call has no
///// cost associated with it and call be called
///// endlessly
//class APICreditCost {
//
//    /// if this is absent then an api call
//    /// costs nothing and can always be called
//    Optional<int> cost;
//
//    /// The manager this cost belongs to
//    /// use this reference to access methods
//    APICreditManager Function() creditManager;
//
//    APICreditCost({@required this.cost, @required this.creditManager});
//
//    /// This call costs nothing
//    APICreditCost.none()
//        : cost = const Optional.absent(),
//            creditManager = null;
//}
//
///// To track the last changes it is needed to remember wheen
///// - the credits were completely renewed
///// - when their were changed the last time
///// - and how much credit there were after the last change
//class APICreditModel {
//
//    /// The last time the credits were completely renewed
//    ///
//    /// if absent then the credits were newer renewed so far
//    Optional<int> lastTotalRenewalInMillisecondsSinceEpoch;
//
//    /// The time the last call was made with an after call
//    /// balance of [lastBalance]
//    ///
//    /// if absent then the there were newer a last change
//    /// i.e. no previous calls were made
//    Optional<int> lastChangeInMillisecondsSinceEpoch;
//
//    /// Tell with how mancy credits the last call ended
//    ///
//    /// if absent then the there were newer a last change
//    /// i.e. no previous calls were made
//    Optional<int> lastBalance;
//
//    factory APICreditModel.init() =>
//        APICreditModel(
//            lastBalance: const Optional.absent(),
//            lastChangeInMillisecondsSinceEpoch: const Optional.absent(),
//            lastTotalRenewalInMillisecondsSinceEpoch: const Optional.absent(),
//        );
//
//    APICreditModel({
//        @required this.lastTotalRenewalInMillisecondsSinceEpoch,
//        @required this.lastChangeInMillisecondsSinceEpoch,
//        @required this.lastBalance,
//    });
//
//    Map<String, dynamic> toJson() =>
//        {
//            "renewed": lastTotalRenewalInMillisecondsSinceEpoch.orNull,
//            "lastChange": lastChangeInMillisecondsSinceEpoch.orNull,
//            "last": lastBalance.orNull,
//        };
//
//    APICreditModel fromJson(String str) {
//        Map<String, dynamic> map = Map.from(json.decode(str));
//
//        return APICreditModel(
//            lastTotalRenewalInMillisecondsSinceEpoch: Optional.fromNullable(map["renewed"]),
//            lastChangeInMillisecondsSinceEpoch: Optional.fromNullable(map["lastChange"]),
//            lastBalance: Optional.fromNullable(map["last"]),
//        );
//    }
//}
