import 'dart:convert';

import 'package:bird/smart_api.dart';
import 'package:test/test.dart';

void main() {
    group("formatting.dart", () {
        group("BodyHelper", () {
            const BodyHelper b = BodyHelper();

            test("empty", () {
                expect(b.empty(), "");
            });

            test("raw", () {
                expect(b.raw("bah"), "bah");
            });

            test("jsonObj", () {
                expect(b.jsonObj(<String, dynamic>{"a": "b"}), '{"a":"b"}');
            });

            test("rpc2_0", () {
                expect(
                    json.decode(b.rpc2_0(method: "null", id: 5, params: <dynamic>[123, "123", true])),
                    {
                        JSON_RPC_Constants.JSONRPC_KEY: JSON_RPC_Constants.JSON_RPC_2_0_VERSION_VALUE,
                        JSON_RPC_Constants.METHOD_KEY: "null",
                        JSON_RPC_Constants.ID_KEY: 5,
                        JSON_RPC_Constants.PARAMS_KEY: [123, "123", true],
                    });
            });
        });
    });
}